from robustocs import load_ped, makeA, make_invA
import numpy as np
from time import time


P = load_ped("example.ped")
A = makeA(P)


def printMatrix(matrix, description="ans =", precision=3):
    """Quick function for nicely printing a matrix"""
    print(f"{description}\n", np.round(matrix, precision))


printMatrix(A)
loops = 10000

tic = time()
for _ in range(loops):
    B = makeA(P)
    invA1 = np.linalg.inv(B)
printMatrix(invA1, f"\n{time()-tic:.2f} seconds for = ")

tic = time()
for _ in range(loops):
    invA2 = make_invA(P)
printMatrix(invA2, f"\n{time()-tic:.2f} seconds for = ")

for _ in range(loops):
    invA3 = make_invA_decomposition(P)
printMatrix(invA3, f"\n{time()-tic:} seconds for = ")


assert np.all(np.abs(invA1-invA2) < 1e-7)
assert np.all(np.abs(invA2-invA3) < 1e-7)
assert np.all(np.abs(invA1-invA3) < 1e-7)
